# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::StreamAnalytics::Mgmt::V2016_03_01
  module Models
    #
    # Describes an Event Hub output data source.
    #
    class EventHubOutputDataSource < OutputDataSource

      include MsRestAzure


      def initialize
        @type = "Microsoft.ServiceBus/EventHub"
      end

      attr_accessor :type

      # @return [String] The namespace that is associated with the desired
      # Event Hub, Service Bus Queue, Service Bus Topic, etc. Required on PUT
      # (CreateOrReplace) requests.
      attr_accessor :service_bus_namespace

      # @return [String] The shared access policy name for the Event Hub,
      # Service Bus Queue, Service Bus Topic, etc. Required on PUT
      # (CreateOrReplace) requests.
      attr_accessor :shared_access_policy_name

      # @return [String] The shared access policy key for the specified shared
      # access policy. Required on PUT (CreateOrReplace) requests.
      attr_accessor :shared_access_policy_key

      # @return [String] The name of the Event Hub. Required on PUT
      # (CreateOrReplace) requests.
      attr_accessor :event_hub_name

      # @return [String] The key/column that is used to determine to which
      # partition to send event data.
      attr_accessor :partition_key


      #
      # Mapper for EventHubOutputDataSource class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Microsoft.ServiceBus/EventHub',
          type: {
            name: 'Composite',
            class_name: 'EventHubOutputDataSource',
            model_properties: {
              type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              service_bus_namespace: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.serviceBusNamespace',
                type: {
                  name: 'String'
                }
              },
              shared_access_policy_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.sharedAccessPolicyName',
                type: {
                  name: 'String'
                }
              },
              shared_access_policy_key: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.sharedAccessPolicyKey',
                type: {
                  name: 'String'
                }
              },
              event_hub_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.eventHubName',
                type: {
                  name: 'String'
                }
              },
              partition_key: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.partitionKey',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
